#include "snipe2d.h"
#include <pwd.h>

extern PREFS gPrefs;
extern char *mediaPath;
const int longest_ini_line = 256;
unsigned pversion; // The version the conf file shows.
const unsigned cversion = 1; // The unchanging version number
struct passwd *pw_ent = getpwuid(geteuid());

void new_prefs()
{
    char datadir[(strlen(pw_ent->pw_dir)+6)];
    char path[(strlen(pw_ent->pw_dir)+6+11)];

    snprintf (datadir, strlen(pw_ent->pw_dir)+6, "%s/.oes", pw_ent->pw_dir);
    snprintf (path, strlen(pw_ent->pw_dir)+17, "%s/.oes/conf.bin",
	      pw_ent->pw_dir);

    {
	FILE *dir = fopen (datadir, "r");
	if (!dir)
	    {
		mkdir (datadir, 0755);
		dir = fopen (datadir, "r");
		if (!dir)
		    {

			fprintf (stderr, "Unable to create personal prefs dir\n");
			exit (1);
		    }
	    }
	fclose (dir);
    }

    gPrefs.fullscreen = 1;
    gPrefs.audio = 1;
    gPrefs.verbose = 2;
    gPrefs.difficulty = 2;
    gPrefs.path = strdup (path);

    gPrefs.f = fopen (path, "r");
    if (!gPrefs.f)
	{
	    gPrefs.f = fopen (path, "wb");
	    if (!gPrefs.f)
		{
		    fprintf (stderr, "Error creating user prefs\n");
		    exit (1);
		}
	    fwrite ((void*)&pversion, sizeof(unsigned), 1, gPrefs.f);
	    fwrite ((void*)&gPrefs.fullscreen, sizeof(char), 1, gPrefs.f);
	    fwrite ((void*)&gPrefs.audio, sizeof(char), 1, gPrefs.f);
	    fwrite ((void*)&gPrefs.verbose, sizeof(char), 1, gPrefs.f);
	    fwrite ((void*)&gPrefs.difficulty, sizeof(char), 1, gPrefs.f);
	}

    fclose (gPrefs.f);
}

void load_prefs()
{
    FILE *f;

    new_prefs();

    f = fopen (gPrefs.path, "rb");
    fread (&pversion, sizeof(unsigned), 1, f);
    switch (pversion)
	{
	case 0: // first version of conf file
	    fread ((void*)&gPrefs.fullscreen, sizeof(char), 1, f);
	    fread ((void*)&gPrefs.audio, sizeof(char), 1, f);
	    fread ((void*)&gPrefs.verbose, sizeof(char), 1, f);
	    break;
	case 1:
	    fread ((void*)&gPrefs.fullscreen, sizeof(char), 1, f);
	    fread ((void*)&gPrefs.audio, sizeof(char), 1, f);
	    fread ((void*)&gPrefs.verbose, sizeof(char), 1, f);
	    fread ((void*)&gPrefs.difficulty, sizeof(char), 1, f);
	    break;
	default:
	    fprintf (stderr, "Unknown config file version: %u\n", pversion);
	    exit (1);
	}

    atexit (save_prefs);
}

void save_prefs()
{
    FILE *f = fopen (gPrefs.path, "w");

    update_prefs();

    fwrite ((void*)&cversion, sizeof(unsigned), 1, f);
    fwrite ((void*)&gPrefs.fullscreen, sizeof(char), 1, f);
    fwrite ((void*)&gPrefs.audio, sizeof(char), 1, f);
    fwrite ((void*)&gPrefs.verbose, sizeof(char), 1, f);
    fwrite ((void*)&gPrefs.difficulty, sizeof(char), 1, f);

    fclose (f);
}

